Loading...
Searching...
No Matches
irr::gui::IGUITable Class Referenceabstract

Default list box GUI element. More...

`#include <IGUITable.h>`

Inheritance diagram for irr::gui::IGUITable:

## Public Member Functions

| IGUITable (IGUIEnvironment *environment, IGUIElement *parent, s32 id, core::rect< s32 > rectangle)
| constructor
virtual void | addColumn (const wchar_t *caption, s32 columnIndex=-1)=0
| Adds a column.
virtual u32 | addRow (u32 rowIndex)=0
| adds a row to the table
virtual void | clear ()=0
| clears the table, deletes all items in the table
virtual void | clearRows ()=0
| clears the table rows, but keeps the columns intact
virtual s32 | getActiveColumn () const =0
| Returns which header is currently active.
virtual EGUI_ORDERING_MODE | getActiveColumnOrdering () const =0
| Returns the ordering used by the currently active column.
virtual void * | getCellData (u32 rowIndex, u32 columnIndex) const =0
| Get the data of a cell.
virtual const wchar_t * | getCellText (u32 rowIndex, u32 columnIndex) const =0
| Get the text of a cell.
virtual s32 | getColumnCount () const =0
| Returns the number of columns in the table control.
virtual u32 | getColumnWidth (u32 columnIndex) const =0
| Get the width of a column.
virtual s32 | getDrawFlags () const =0
| Get the flags, as defined in EGUI_TABLE_DRAW_FLAGS, which influence the layout.
virtual s32 | getRowCount () const =0
| Get amount of rows in the tabcontrol.
virtual s32 | getSelected () const =0
| Returns which row is currently selected.
virtual bool | hasResizableColumns () const =0
| can columns be resized by dran 'n drop?
virtual void | orderRows (s32 columnIndex=-1, EGUI_ORDERING_MODE mode=EGOM_NONE)=0
| This tells the table to start ordering all the rows.
virtual void | removeColumn (u32 columnIndex)=0
| remove a column from the table
virtual void | removeRow (u32 rowIndex)=0
| Remove a row from the table.
virtual bool | setActiveColumn (s32 idx, bool doOrder=false)=0
| Makes a column active. This will trigger an ordering process.
virtual void | setCellColor (u32 rowIndex, u32 columnIndex, video::SColor color)=0
| Set the color of a cell text.
virtual void | setCellData (u32 rowIndex, u32 columnIndex, void *data)=0
| Set the data of a cell.
virtual void | setCellText (u32 rowIndex, u32 columnIndex, const core::stringw &text)=0
| Set the text of a cell.
virtual void | setCellText (u32 rowIndex, u32 columnIndex, const core::stringw &text, video::SColor color)=0
| Set the text of a cell, and set a color of this cell.
virtual void | setColumnOrdering (u32 columnIndex, EGUI_COLUMN_ORDERING mode)=0
| This tells the table control which ordering mode should be used when a column header is clicked.
virtual void | setColumnWidth (u32 columnIndex, u32 width)=0
| Set the width of a column.
virtual void | setDrawFlags (s32 flags)=0
| Set flags, as defined in EGUI_TABLE_DRAW_FLAGS, which influence the layout.
virtual void | setResizableColumns (bool resizable)=0
| columns can be resized by drag 'n drop
virtual void | setSelected (s32 index)=0
| set wich row is currently selected
virtual void | swapRows (u32 rowIndexA, u32 rowIndexB)=0
| Swap two row positions.
Public Member Functions inherited from irr::gui::IGUIElement
| IGUIElement (EGUI_ELEMENT_TYPE type, IGUIEnvironment *environment, IGUIElement *parent, s32 id, const core::rect< s32 > &rectangle)
| Constructor.
virtual | ~IGUIElement ()
| Destructor.
virtual void | addChild (IGUIElement *child)
| Adds a GUI element as new child of this element.
virtual bool | bringToFront (IGUIElement *element)
| Brings a child to front.
virtual void | deserializeAttributes (io::IAttributes *in, io::SAttributeReadWriteOptions *options=0)
| Reads attributes of the scene node.
virtual void | draw ()
| Draws the element and its children.
core::rect< s32 > | getAbsoluteClippingRect () const
| Returns the visible area of the element.
core::rect< s32 > | getAbsolutePosition () const
| Gets the absolute rectangle of this element.
virtual const core::list< IGUIElement * > & | getChildren () const
| Returns list with children of this element.
virtual IGUIElement * | getElementFromId (s32 id, bool searchchildren=false) const
| Finds the first element with the given id.
IGUIElement * | getElementFromPoint (const core::position2d< s32 > &point)
| Returns the topmost GUI element at the specific position.
virtual s32 | getID () const
| Returns id. Can be used to identify the element.
virtual const c8 * | getName () const
| Returns the name of the element.
bool | getNextElement (s32 startOrder, bool reverse, bool group, IGUIElement *&first, IGUIElement *&closest, bool includeInvisible=false) const
| searches elements to find the closest next element to tab to
IGUIElement * | getParent () const
| Returns parent of this element.
core::rect< s32 > | getRelativePosition () const
| Returns the relative rectangle of this element.
IGUIElement * | getTabGroup ()
| Returns the container element which holds all elements in this element's tab group.
s32 | getTabOrder () const
| Returns the number in the tab order sequence.
virtual const wchar_t * | getText () const
| Returns caption of this element.
virtual const core::stringw & | getToolTipText () const
| Returns caption of this element.
EGUI_ELEMENT_TYPE | getType () const
| Returns the type of the gui element.
virtual const c8 * | getTypeName () const
| Returns the type name of the gui element.
virtual bool | hasType (EGUI_ELEMENT_TYPE type) const
| Returns true if the gui element supports the given type.
virtual bool | isEnabled () const
| Returns true if element is enabled.
bool | isMyChild (IGUIElement *child) const
bool | isNotClipped () const
| Gets whether the element will ignore its parent's clipping rectangle.
virtual bool | isPointInside (const core::position2d< s32 > &point) const
| Returns true if a point is within this element.
virtual bool | isSubElement () const
| Returns true if this element was created as part of its parent control.
bool | isTabGroup () const
| Returns true if this element is a tab group.
bool | isTabStop () const
| Returns true if this element can be focused by navigating with the tab key.
virtual bool | isVisible () const
| Returns true if element is visible.
virtual void | move (core::position2d< s32 > absoluteMovement)
| Moves this element.
virtual bool | OnEvent (const SEvent &event)
| Called if an event happened.
virtual void | OnPostRender (u32 timeMs)
| animate the element and its children.
virtual void | remove ()
| Removes this element from its parent.
virtual void | removeChild (IGUIElement *child)
| Removes a child.
virtual bool | sendToBack (IGUIElement *child)
| Moves a child to the back, so it's siblings are drawn on top of it.
virtual void | serializeAttributes (io::IAttributes *out, io::SAttributeReadWriteOptions *options=0) const
| Writes attributes of the scene node.
void | setAlignment (EGUI_ALIGNMENT left, EGUI_ALIGNMENT right, EGUI_ALIGNMENT top, EGUI_ALIGNMENT bottom)
| The alignment defines how the borders of this element will be positioned when the parent element is resized.
virtual void | setEnabled (bool enabled)
| Sets the enabled state of this element.
virtual void | setID (s32 id)
| Sets the id of this element.
void | setMaxSize (core::dimension2du size)
| Sets the maximum size allowed for this element.
void | setMinSize (core::dimension2du size)
| Sets the minimum size allowed for this element.
virtual void | setName (const c8 *name)
| Sets the name of the element.
virtual void | setName (const core::stringc &name)
| Sets the name of the element.
void | setNotClipped (bool noClip)
| Sets whether the element will ignore its parent's clipping rectangle.
void | setRelativePosition (const core::position2di &position)
| Sets the relative rectangle of this element, maintaining its current width and height.
void | setRelativePosition (const core::rect< s32 > &r)
| Sets the relative rectangle of this element.
void | setRelativePositionProportional (const core::rect< f32 > &r)
| Sets the relative rectangle of this element as a proportion of its parent's area.
virtual void | setSubElement (bool subElement)
| Sets whether this control was created as part of its parent.
void | setTabGroup (bool isGroup)
| Sets whether this element is a container for a group of elements which can be navigated using the tab key.
void | setTabOrder (s32 index)
| Sets the priority of focus when using the tab key to navigate between a group of elements.
void | setTabStop (bool enable)
| If set to true, the focus will visit this element when using the tab key to cycle through elements.
virtual void | setText (const wchar_t *text)
| Sets the new caption of this element.
virtual void | setToolTipText (const wchar_t *text)
| Sets the new caption of this element.
virtual void | setVisible (bool visible)
| Sets the visible state of this element.
virtual void | updateAbsolutePosition ()
| Updates the absolute position.
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.
Public Member Functions inherited from irr::IEventReceiver
virtual | ~IEventReceiver ()
| Destructor.

## Additional Inherited Members

Protected Member Functions inherited from irr::gui::IGUIElement
void | addChildToEnd (IGUIElement *child)
void | recalculateAbsolutePosition (bool recursive)
Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.
Protected Attributes inherited from irr::gui::IGUIElement
core::rect< s32 > | AbsoluteClippingRect
| absolute clipping rect of element
core::rect< s32 > | AbsoluteRect
| absolute rect of element
EGUI_ALIGNMENT | AlignBottom
EGUI_ALIGNMENT | AlignLeft
| tells the element how to act when its parent is resized
EGUI_ALIGNMENT | AlignRight
EGUI_ALIGNMENT | AlignTop
core::list< IGUIElement * > | Children
| List of all children of this element.
core::rect< s32 > | DesiredRect
IGUIEnvironment * | Environment
| GUI Environment.
s32 | ID
| users can set this for identificating the element by integer
bool | IsEnabled
| is enabled?
bool | IsSubElement
| is a part of a larger whole and should not be serialized?
bool | IsTabGroup
| tab groups are containers like windows, use ctrl+tab to navigate
bool | IsTabStop
| tab stop like in windows
bool | IsVisible
| is visible?
core::rect< s32 > | LastParentRect
| for calculating the difference when resizing parent
core::dimension2du | MaxSize
| maximum and minimum size of the element
core::dimension2du | MinSize
core::stringc | Name
| users can set this for identificating the element by string
bool | NoClip
| does this element ignore its parent's clipping rectangle?
IGUIElement * | Parent
| Pointer to the parent.
core::rect< s32 > | RelativeRect
| relative rect of element
core::rect< f32 > | ScaleRect
| relative scale of the element inside its parent
s32 | TabOrder
| tab order
core::stringw | Text
| caption
core::stringw | ToolTipText
| tooltip
EGUI_ELEMENT_TYPE | Type
| type of element

## Detailed Description

Default list box GUI element.

This element can create the following events of type EGUI_EVENT_TYPE:
  - EGET_TABLE_CHANGED
  - EGET_TABLE_SELECTED_AGAIN
  - EGET_TABLE_HEADER_CHANGED

Definition at line 89 of file IGUITable.h.

## Constructor & Destructor Documentation

## IGUITable()

irr::gui::IGUITable::IGUITable | ( | IGUIEnvironment * | environment,
|  | IGUIElement * | parent,
|  | s32 | id,
|  | core::rect< s32 > | rectangle )

inline

constructor

Definition at line 93 of file IGUITable.h.

References irr::gui::IGUIElement::IGUIElement(), and irr::gui::EGUIET_TABLE.

## Member Function Documentation

## addColumn()

virtual void irr::gui::IGUITable::addColumn | ( | const wchar_t * | caption,
|  | s32 | columnIndex = -1 )

pure virtual

Adds a column.

If columnIndex is outside the current range, do push new colum at the end

## addRow()

virtual u32 irr::gui::IGUITable::addRow | ( | u32 | rowIndex | ) |

pure virtual

adds a row to the table

Parameters

  rowIndex | Zero based index of rows. The row will be inserted at this position, if a row already exist there, it will be placed after it. If the row is larger than the actual number of row by more than one, it won't be created. Note that if you create a row that's not at the end, there might be performance issues.

Returns
  index of inserted row.

## clear()

virtual void irr::gui::IGUITable::clear | ( |  | ) |

pure virtual

clears the table, deletes all items in the table

## clearRows()

virtual void irr::gui::IGUITable::clearRows | ( |  | ) |

pure virtual

clears the table rows, but keeps the columns intact

## getActiveColumn()

virtual s32 irr::gui::IGUITable::getActiveColumn | ( |  | ) | const

pure virtual

Returns which header is currently active.

## getActiveColumnOrdering()

virtual EGUI_ORDERING_MODE irr::gui::IGUITable::getActiveColumnOrdering | ( |  | ) | const

pure virtual

Returns the ordering used by the currently active column.

## getCellData()

virtual void * irr::gui::IGUITable::getCellData | ( | u32 | rowIndex,
|  | u32 | columnIndex ) const

pure virtual

Get the data of a cell.

## getCellText()

virtual const wchar_t * irr::gui::IGUITable::getCellText | ( | u32 | rowIndex,
|  | u32 | columnIndex ) const

pure virtual

Get the text of a cell.

## getColumnCount()

virtual s32 irr::gui::IGUITable::getColumnCount | ( |  | ) | const

pure virtual

Returns the number of columns in the table control.

## getColumnWidth()

virtual u32 irr::gui::IGUITable::getColumnWidth | ( | u32 | columnIndex | ) | const

pure virtual

Get the width of a column.

## getDrawFlags()

virtual s32 irr::gui::IGUITable::getDrawFlags | ( |  | ) | const

pure virtual

Get the flags, as defined in EGUI_TABLE_DRAW_FLAGS, which influence the layout.

## getRowCount()

virtual s32 irr::gui::IGUITable::getRowCount | ( |  | ) | const

pure virtual

Get amount of rows in the tabcontrol.

## getSelected()

virtual s32 irr::gui::IGUITable::getSelected | ( |  | ) | const

pure virtual

Returns which row is currently selected.

## hasResizableColumns()

virtual bool irr::gui::IGUITable::hasResizableColumns | ( |  | ) | const

pure virtual

can columns be resized by dran 'n drop?

## orderRows()

virtual void irr::gui::IGUITable::orderRows | ( | s32 | columnIndex = -1,
|  | EGUI_ORDERING_MODE | mode = EGOM_NONE )

pure virtual

This tells the table to start ordering all the rows.

You need to explicitly tell the table to re order the rows when a new row is added or the cells data is changed. This makes the system more flexible and doesn't make you pay the cost of ordering when adding a lot of rows.

Parameters

  columnIndex | When set to -1 the active column is used.
  mode | Ordering mode of the rows.

References irr::gui::EGOM_NONE.

## removeColumn()

virtual void irr::gui::IGUITable::removeColumn | ( | u32 | columnIndex | ) |

pure virtual

remove a column from the table

## removeRow()

virtual void irr::gui::IGUITable::removeRow | ( | u32 | rowIndex | ) |

pure virtual

Remove a row from the table.

## setActiveColumn()

virtual bool irr::gui::IGUITable::setActiveColumn | ( | s32 | idx,
|  | bool | doOrder = false )

pure virtual

Makes a column active. This will trigger an ordering process.

Parameters

  idx | The id of the column to make active.
  doOrder | Do also the ordering which depending on mode for active column

Returns
  True if successful.

## setCellColor()

virtual void irr::gui::IGUITable::setCellColor | ( | u32 | rowIndex,
|  | u32 | columnIndex,
|  | video::SColor | color )

pure virtual

Set the color of a cell text.

## setCellData()

virtual void irr::gui::IGUITable::setCellData | ( | u32 | rowIndex,
|  | u32 | columnIndex,
|  | void * | data )

pure virtual

Set the data of a cell.

## setCellText() [1/2]

virtual void irr::gui::IGUITable::setCellText | ( | u32 | rowIndex,
|  | u32 | columnIndex,
|  | const core::stringw & | text )

pure virtual

Set the text of a cell.

## setCellText() [2/2]

virtual void irr::gui::IGUITable::setCellText | ( | u32 | rowIndex,
|  | u32 | columnIndex,
|  | const core::stringw & | text,
|  | video::SColor | color )

pure virtual

Set the text of a cell, and set a color of this cell.

## setColumnOrdering()

virtual void irr::gui::IGUITable::setColumnOrdering | ( | u32 | columnIndex,
|  | EGUI_COLUMN_ORDERING | mode )

pure virtual

This tells the table control which ordering mode should be used when a column header is clicked.

Parameters

  columnIndex | The index of the column header.
  mode | One of the modes defined in EGUI_COLUMN_ORDERING

## setColumnWidth()

virtual void irr::gui::IGUITable::setColumnWidth | ( | u32 | columnIndex,
|  | u32 | width )

pure virtual

Set the width of a column.

## setDrawFlags()

virtual void irr::gui::IGUITable::setDrawFlags | ( | s32 | flags | ) |

pure virtual

Set flags, as defined in EGUI_TABLE_DRAW_FLAGS, which influence the layout.

## setResizableColumns()

virtual void irr::gui::IGUITable::setResizableColumns | ( | bool | resizable | ) |

pure virtual

columns can be resized by drag 'n drop

## setSelected()

virtual void irr::gui::IGUITable::setSelected | ( | s32 | index | ) |

pure virtual

set wich row is currently selected

## swapRows()

virtual void irr::gui::IGUITable::swapRows | ( | u32 | rowIndexA,
|  | u32 | rowIndexB )

pure virtual

Swap two row positions.

The documentation for this class was generated from the following file:

- IGUITable.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0